/*
 *	picslice.h
 *	- 65536FPICt@C̕[_
 *	  Jan. 1994	A.Tan (Oh!X)
 */

#ifndef	__PICSLICE_H__
#define	__PICSLICE_H__

/* PIC[hi[\ */
typedef struct _picsliceinfo {
	int		filehandle;		/* t@Cnh */
	unsigned char	*filebuf;		/* t@C̈ꎞǂݍ݃obt@ */
	long		filebufsize;		/* ̃TCY */
	int		currentbyte;		/* filebuf ̓ǂݍ݈ʒu */
	int		realwidth;		/* 摜̐^̕ */
	int		width;			/* 摜̃[h̕ */
	int		height;			/* c̒ */
	int		currenty;		/* ǂ܂Ń[h */
	long		runlength;		/* ω_Ԃ̋уJE^ */
	unsigned short	color;			/* ω_Ԃ̐F */
	unsigned short	*chainbuf;		/* Aobt@ */
	int		chainbufsize;		/* Aobt@̃TCY */
	long		top;			/* oXg̐擪 */
	long		bottom;			/* oXg̖ */
	long		freelist;		/* t[Xg̐擪 */
	int		bytecount;		/* oCgPʂ̃JE^ */
	int		bitcount;		/* rbgPʂ̃JE^ */
	unsigned short	colortable[128];	/* FXg */
	int		nexttable[128];		/* F|C^ */
	int		prevtable[128];		/* OF|C^ */
	unsigned short	currentcolor;		/* ݐF */
} picsliceinfo;

/* t[obt@̉̌߂ */
#define		PICSLICE_GRAM		101
#define		PICSLICE_EXACT		102
#define		PICSLICE_EVEN		103

/* ^[R[h */
#define		PICSLICE_NORMAL		200
#define		PICSLICE_TERMINATE	201
#define		PICSLICE_EFORMAT	202
#define		PICSLICE_EREAD		203
#define		PICSLICE_EOVERFLOW	204

/* JĂ֐ */
int	picsliceOpen( picsliceinfo *psi, int mode );
int	picsliceLoad( picsliceinfo *psi, unsigned short *frame, int raster );

#endif	/* __PICSLICE_H__ */
