RUNS_HUMAN_VERSION	equ	3
	.cpu 68000
	.include doscall.mac

	.text
	.even


	.globl	_RectPut
	.globl	_aspnormalize
	.globl	_aspn65
	.globl	_SetPalet
	.globl	_getgmode
	.globl	_EndOfDraw
	.globl	_iclr
	.globl	_putug

	.xref _psi
	.xref _gmode
	.xref _curgmode
	.xref _drawing
	.xref _drawfunc
	.xref _WindowSetGraphicMode

_RectPut:
	movem.l d3/d4/d5/d6/d7/a3/a4/a5,-(sp)
	lea _psi,a4
	move.w 22(a4),d5	*x = width
	moveq.l #0,d6		*y = 0
	move.l 16(a4),d7	*realwidth
	cmp.w 26(a4),d7		*height
	bgt ylpstart
	cmp.w d5,d7		*width
	ble rectputend
ylpstart:
	move.l d7,d2		*realwidth
	add.w d2,d2
ylp:
	move.w d6,d0		*y
	add.w 26(a4),d0		*height
	move.l d7,d3		*realwidth
	cmp.w d0,d3
	bge yinview
	sub.w d6,d3		*k = realwidth - y
	bra xlpent
yinview:
	move.w 26(a4),d3	*k = height
xlpent:
	subq.w #1,d3
	move.w d6,d0		*y
	mulu d7,d0		*realwidth
	add.l d0,d0
	move.l d0,a5
xlp:
	move.l #12582912,a3	*srcptr = c00000
	move.w d5,d0		*x
	add.w d0,d0
	lea.l (a3,d0.w),a0
	add.l a5,a0		*destptr
	move.w d5,d0		*x
	add.w 22(a4),d0		*width
	cmp.w d0,d7		*realwidth
	bge xinview
	move.w d7,d4
	sub.w d5,d4		*j= realwidth - x
	bpl putstart
	moveq.l #0,d4
	bra putstart
xinview:
	move.w 22(a4),d4	*j = width
putstart:
	move.w d3,d1
putylp:
	move.l a3,a2		*tmpsptr= srcptr
	move.l a0,a1		*tmpdptr= destptr
	move.w d4,d0		*j
	bra putxlpent
putxlp:
	move.w (a3)+,(a0)+	*destptr++ = srcptr++
putxlpent:
	dbra d0,putxlp
	lea (a2,d2.w),a3	*srcptr += realwidth
	lea (a1,d2.w),a0	*destptr += realwidth
putylpent:
	dbra d1,putylp		*k
	add.w 22(a4),d5		*x + = width
	cmp.w d7,d5		*realwidth x
	blt xlp
	clr.w d5		*x= 0
	add.w 26(a4),d6		*y += height
	cmp.w d6,d7		*y realwidth
	bgt ylp
rectputend:
	movem.l (sp)+,d3/d4/d5/d6/d7/a3/a4/a5
	rts
	.even

_aspnormalize:
	move.l _curgmode,d0
	cmp.l #2,d0
	beq _setaspn65
	movem.l d3/d4/a3,-(sp)
	clr.l -(sp)
	DOS _SUPER
	move.l d0,(sp)
	lea _psi,a0
	lea.l $c00000,a2
	movea.l a2,a3
	move.w #$eeee,d1
	move.l 20(a0),d2	*width
	move.l 24(a0),d3	*height
	move.l 16(a0),d4	*realwidth
	cmp.l d3,d4		*height
	bgt an_yinview
	move.l d4,d3
an_yinview:
	cmp.l d2,d4		*width
	bgt an_xinview
	move.l d4,d2
an_xinview:
	add.w d4,d4
	move.l d2,20(a0)
	move.w d3,d0
	add.w d0,d0
	add.w d3,d0
	lsr.w #2,d0
	move.l d0,24(a0)
	bra an_ylpent
an_ylp:
	rol.w d1
	bcc an_nextline
	move.w d2,d0
	movea.l a3,a0
	movea.l a2,a1
	bra an_xlpent
an_xlp:
	move.w (a0)+,(a1)+
an_xlpent:
	dbra d0,an_xlp
	lea.l (a2,d4.l),a2
an_nextline
	lea.l (a3,d4.l),a3
an_ylpent:
	dbra d3,an_ylp
	jbsr _RectPut
	DOS _SUPER
	addq.l #4,sp
	movem.l (sp)+,d3/d4/a3
	rts
	.even

_setaspn65:
	lea _psi,a0
	moveq.l #0,d1
	move.l d1,12(a0)	*y(currentbyte)
	lea 28(a0),a1		*lx(currenty)
	move.l 16(a0),d0	*realwidth
	move.l 20(a0),d1	*width
	cmp.l d0,d1		*width
	ble an65_xinview
	move.l d0,d1
an65_xinview:
	move.l d1,(a1)+
*	move.l d1,20(a0)	*width
	move.l 24(a0),d1	*height
	cmp.l d0,d1		*realwidth
	ble an65_yinview
	move.l d0,d1
an65_yinview:
	move.l d1,(a1)		*ly(runlength)
	move.l d1,d0
	add.w d0,d0
	add.w d0,d1
	lsr.w #2,d1
	move.l d1,24(a0)	*height
	move.l #$c00000,46(a0)	*linetop(top)
	moveq.l #1,d1
	move.l d1,_drawing
	move.l #_aspn65,_drawfunc
	moveq.l #0,d0
	rts
	.even

_aspn65:
	movem.l d3/d4/d5/d6/d7/a3/a4/a5/a6,-(sp)
	move.l _dy,d5		*d(dy)
	lea _psi,a0
	move.l 12(a0),d7	*y(currentbyte)
	move.l 28(a0),a6	*lx(currenty)
	move.l 32(a0),a3	*ly(runlength)
	move.l 46(a0),a5	*linetop(top)

	clr.l -(sp)
	DOS _SUPER
	move.l d0,(sp)
	bra an65_ylpent
an65_ylp:
	addq.w #1,d7
	cmp.w a6,d7		*lx(currenty)
	ble an65_inview
	jbsr _RectPut
	moveq.l #0,d0
	move.l d0,_drawing
	bra aspn65_end
an65_inview:
	movea.l a5,a1		*write= linetop
	addq.l #2,a5
	movea.l a1,a0		*read= write
	move.l a3,d6		*y
	move.l #%1111101111011111_1111001110011111,d4
an65_xlp:
	subq.w #1,d6
	bmi an65_ylpent
	moveq.l #0,d0
	move.w (a0),d0		*pixel0

	subq.w #1,d6
	bmi an65_ylpent

	lea.l 1024(a0),a0
	moveq.l #0,d1
	move.w (a0),d1		*pixel1

	lsr.w #1,d0		*pixel0
	lsr.w #1,d1		*pixel1
	move.l d1,a2

	move.l d0,d2		*pixel0
	move.l d1,d3		*pixel1
	and.w d4,d0
	and.w d4,d1

	move.l d0,a4		*pixel0
	add.w d0,d0
	add.w a4,d1
	add.l d1,d0		*d0 * 3 + d1

	not.w d4
	and.w d4,d2
	and.w d4,d3

	move.l d2,a4
	add.w d2,d2
	add.w a4,d3
	add.l d3,d2
	not.w d4
	and.w d4,d2

	add.l d2,d0
	lsr.l #2,d0
	add.w d0,d0

	move.w d0,(a1)		*new0

	move.l a2,d1
	subq.w #1,d6
	bmi an65_ylpent
	lea.l 1024(a1),a1
	lea.l 1024(a0),a0
	moveq.l #0,d0
	move.w (a0),d0		*pixel2


	lsr.w #1,d0
	move.l d0,a4
	swap.w d4

	move.w d0,d2
	move.w d1,d3
	and.w d4,d0
	and.w d4,d1
	add.w d1,d0
	not.w d4
	and.w d4,d2
	and.w d4,d3
	add.w d3,d2
	not.w d4
	and.w d4,d2
	add.w d2,d0
	and.w #$fffe,d0

	move.w d0,(a1)

	subq.w #1,d6
	bmi an65_ylpent

	lea.l 1024(a1),a1	*write
	lea.l 1024(a0),a0	*read
	move.w (a0),d0		*pixel3

	lsr.w #1,d0
	move.l a4,d1
	swap.w d4
	move.l d0,d2
	move.l d1,d3
	and.w d4,d0
	and.w d4,d1
	move.l d0,a4
	add.w d0,d0
	add.w a4,d1
	add.l d1,d0
	not.w d4
	and.w d4,d2
	and.w d4,d3
	move.l d2,a4
	add.w d2,d2
	add.w a4,d3
	add.l d3,d2
	not.w d4
	and.w d4,d2
	add.l d2,d0
	lsr.l #2,d0
	add.w d0,d0

	move.w d0,(a1)
	lea.l 1024(a1),a1
	lea.l 1024(a0),a0
	bra an65_xlp
an65_ylpent:
	dbra d5,an65_ylp	*d
	lea _psi,a0
	move.l d7,12(a0)
	move.l a5,46(a0)
aspn65_end:
	DOS _SUPER
	addq.l #4,sp
	movem.l (sp)+,d3/d4/d5/d6/d7/a3/a4/a5/a6
	rts
	.even

_SetPalet:
	move.l _curgmode,d0
	addq.w #1,d0
	add.w d0,d0
	add.w d0,d0
	move.l d0,-(sp)
	jbsr _WindowSetGraphicMode
	move.l _curgmode,d0
	cmp.w #2,d0
	bne palsetstart
	movea.l 8(sp),a0
	moveq.l #$7f,d0
	moveq.l #1,d1
set65lp:
	move.w d1,(a0)+
	move.w d1,(a0)+
	add.w #$202,d1
	dbra d0,set65lp
palsetstart:
	clr.l (sp)
	DOS _SUPER
	move.l d0,(sp)
	move.l #15212544,a1	*e82000
	move.l 8(sp),a0		*palptr
	move.l 12(sp),d0	*palnum
	subq.w #1,d0
palsetlp:
	move.w (a0)+,(a1)+
palsetent:
	dbra d0,palsetlp
	DOS _SUPER
	addq.w #4,sp
	rts
	.even

_getgmode:
	move.l 4(sp),a1
	clr.l -(sp)
	DOS _SUPER
	move.l d0,(sp)
	lea.l $e82000,a0
	moveq.l #$7f,d0
getpallp:
	move.l (a0)+,(a1)+
	dbra d0,getpallp
	moveq.l #0,d1
	move.b $e80028,d1
	and.b #3,d1
	cmp.b #3,d1
	bne getgmodeend
	subq.b #1,d1
getgmodeend:
	DOS _SUPER
	addq.w #4,sp
	move.l d1,d0
	rts
	.even

_EndOfDraw:
	lea _psi,a1
	moveq.l #0,d1
	move.l (a1),d0
	beq nofilehandle
	move.w d0,-(sp)
	DOS _CLOSE
	move.l d1,(a1)
	addq.w #2,sp
nofilehandle:
	move.l 4(a1),d0
	beq nofilebuf
	move.l d0,-(sp)
	DOS _MFREE
	move.l d1,4(a1)
	addq.w #4,sp
nofilebuf:
	move.l 38(a1),d0
	beq nochainbuf
	move.l d0,-(sp)
	DOS _MFREE
	move.l d1,38(a1)
	addq.w #4,sp
nochainbuf:
	move.l d1,_drawing
	rts
	.even

_iclr:				*gram i bit clr
	clr.l	-(sp)
	DOS	_SUPER
	move.l	d0,(sp)

	lea.l $00c00000,a1	*GRAM

	move.l #$fffefffe,d2
clrylp:
	move.w #512*512/16-1,d1
clrxlp:
	and.l d2,(a1)+
	and.l d2,(a1)+
	and.l d2,(a1)+
	and.l d2,(a1)+
	and.l d2,(a1)+
	and.l d2,(a1)+
	and.l d2,(a1)+
	and.l d2,(a1)+

	dbra d1,clrxlp

	DOS	_SUPER
	addq.l	#4,sp
	rts

	.even
_putug:
	movea.l 4(sp),a0	*ug
	movem.l d3-d7/a3-a4,-(sp)
	clr.l -(sp)
	DOS _SUPER
	move.l d0,(sp)
	lea _psi,a1
	move.l #512,d5		*dv(ylp ct)
	move.l (a0)+,d0		*sh
	move.l (a0)+,d4		*sv
	move.l (a0)+,d3		*ug->color
	lsr.w #2,d3
	subq.w #1,d3
	bne pu_512
	add.w d5,d5
pu_512:
	move.l	d5,a4
	adda.l	a4,a4
	move.l d5,16(a1)
	move.l d5,d1		*dh(xlp ct)
	cmp.w d0,d4
	bge pu_longv
	move.l d4,d2
	mulu d5,d2
	divu d0,d2
	move.w d2,d5
	bra pu_art
pu_longv:
	move.l d0,d2
	mulu d5,d2
	divu d4,d2
	move.w d2,d1
pu_art:
	move.l d0,d7

	divu.w d1,d0
	move.w d0,d2
	swap.w d2
	clr.w d0
	divu.w d1,d0
	move.w d0,d2		*sh/dh

	divu.w d5,d4
	move.w d4,d6
	swap.w d6
	clr.w d4
	divu.w d5,d4
	move.w d4,d6		*sv/dv

	move.l d1,20(a1)
	move.l d5,24(a1)
	movea.l (a0),a0
	lea.l $c00000,a1
	moveq.l #0,d4
	movea.l a0,a2
	subq.w	#2,d3
	beq puylpent
	bra pu16ylpent
puylp:
	swap.w d5
	movea.l a1,a3
	move.w d1,d5
	moveq.l #0,d3
	bra puxlpent
puxlp:
	move.l d3,d0
	swap.w	d0
	add.w d0,d0
	move.w (a2,d0.w),(a3)+
	add.l d2,d3
puxlpent:
	dbra d5,puxlp
	lea.l 1024(a1),a1
	move.l d4,d0
	clr.w d0
	swap.w d0
	mulu d7,d0
	add.l d0,d0
	lea.l (a0,d0.l),a2
	add.l d6,d4
	swap.w d5
puylpent:
	dbra d5,puylp
	bra pu_end

pu16ylp:
	swap.w d5
	movea.l a1,a3
	move.w d1,d5
	moveq.l #0,d3
	bra pu16xlpent
pu16xlp:
	swap.w d3
	move.b (a2,d3.w),d0
	move.w d0,(a3)+
	swap.w d3
	add.l d2,d3
pu16xlpent:
	dbra d5,pu16xlp
	adda.l a4,a1
	move.l d4,d0
	clr.w d0
	swap.w d0
	mulu d7,d0	
	lea.l (a0,d0.l),a2
	add.l d6,d4
	swap.w d5
pu16ylpent:
	dbra d5,pu16ylp
pu_end:
	jbsr _RectPut
	DOS _SUPER
	addq.w #4,sp
	movem.l (sp)+,d3-d7/a3-a4
	rts

	.even
	.end
